#include "param.h"

void lcd_writechar (unsigned char x,unsigned char y,unsigned char c,unsigned char fontnr);			// Write char to LCD (X: Byte/2, Y: Line, C: ASCII, Fontnr: Font)
void lcd_writebyte (unsigned char x, unsigned char y, unsigned char c);												// Write data byte to LCD  (X: Byte, Y: Line, C: 8pixel)
void lcd_writebyteg (unsigned char x, unsigned char y, unsigned char c);											// Write Grayscale data byte to LCD  (X: Nibble, Y: Line, C: 4pixel)
void lcd_writebyteex (unsigned char x,unsigned char y,unsigned char c,unsigned char textcol,unsigned char backcol); // Write BW data byte to LCD, expand colors to 4bpp  (X: Byte, Y: Line, C: 8pixel)
void lcd_setpixel (uint16_t x, unsigned short y, unsigned char c);											// Write pixel to LCD  (X: Pixel, Y: Line, C: color)
void lcd_invpixel (uint16_t x, unsigned short y);															// Invert pixel at LCD  (X: Pixel, Y: Line)
void lcd_invnibbel (uint8_t x, unsigned short y);															// Invert nibbel at LCD  (X: Pixel, Y: Line)
void lcd_invblock (unsigned short x1, unsigned short y1, unsigned short x2, unsigned short y2);

void lcd_line (unsigned short x1, unsigned short y1, unsigned short x2, unsigned short y2, unsigned char color);
void lcd_block (unsigned short x1, unsigned short y1, unsigned short x2, unsigned short y2, unsigned char color, unsigned char color2);
void lcd_circle (unsigned short xm, unsigned short ym, unsigned char r, unsigned char color1, unsigned char color2);
void lcd_clear (void);
void lcd_init (void);
void ram_writenibbel (unsigned char x, unsigned char y, unsigned char c);

#ifdef STARTMON
void lcd_string (unsigned char x, unsigned char y,const char *txt, unsigned char font);
#endif


#define ENABLE_VLCD     PORTD_7
#define LCD_LED_PIN		PORTD_5
