.nolist
#include <avr/io.h>
#include "param.h"

.list
.section .bss

//YCnt:		.ds.b	1

#define	R_RAS	r3
#define	R_CAS	r4
#define	R_RAS_W	r5
#define	R_CAS_W r6

.section .text

#include "lcdisr.S"
#include "lcdwchar.S"

// -------------------------
// SET Pixel

.global lcd_setpixel		// X: r25:r24  Sonstige register r21,r19,r18,r17
lcd_setpixel:				// Y: r22		
							// C: r20
	push	r17
	push	r18
	push	r19
	push	r21
	push	r22
	push	r24
	push	r25

	mov r21, r24
	andi r21, 3
	ldi r19, 128
	cpi r21, 0
	breq exitshift
shift:						// r19 = 128>>r21
	lsr r19
	dec r21
	brne shift
exitshift:
	lsr r25
	ror r24
	lsr r25
	ror r24

	mov		r18, r19
	com		r18
//Frame 0
	cli

	out		LCD_dataport,	r22			//	ROW Adresse							
	out		LCD_com0port,	R_RAS		//	RAS	Signal
	out		LCD_dataport,	r24			//	Col Adresse
	out		LCD_com0port,	R_CAS		//	CAS	Signal
	cbi		LCD_com0port,	Drv_dir		//	B->A
	clr		r17
	out		LCD_dataddr,	r17			//	Port als eingang
	cbi		LCD_com0port,	Drv_E
	nop
	nop
	nop
	nop
	in		r21, LCD_datapin			//	Daten lesen
	sbi		LCD_com0port,	Drv_E
	ser		r17
	out		LCD_dataddr,	r17			//	Port als ausgang
	sbi		LCD_com0port,	Drv_dir		//  A->B
	sbi		LCD_com0port,	RAM_OE	
	cbi		LCD_com0port,	Drv_E
	sbrs	r20, 7
	and		r21,	r18						//	Bit lschen
	sbrc	r20, 7
	or		r21,	r19						//	Bit setzen
	out		LCD_dataport,	r21			// Daten ausgeben
	nop
	cbi		LCD_com0port,	RAM_WE
	sbi		LCD_com0port,	Drv_E
//frame1
	lds		r22, Graymode							// SW / 4GW mode?
	tst		r22
	breq	nogmpixel

	out		LCD_com0port,	R_RAS		//	RAS	Signal
	subi	r24,	-128
	out		LCD_dataport,	r24			//	Col Adresse
	out		LCD_com0port,	R_CAS		//	CAS	Signal
	cbi		LCD_com0port,	Drv_dir		//	B->A
	clr		r17
	out		LCD_dataddr,	r17			//	Port als eingang
	cbi		LCD_com0port,	Drv_E
	nop	
	nop
	nop
	nop
	in		r21, LCD_datapin			//	Daten lesen
	sbi		LCD_com0port,	Drv_E
	ser		r17
	out		LCD_dataddr,	r17			//	Port als ausgang
	sbi		LCD_com0port,	Drv_dir		//  A->B
	sbi		LCD_com0port,	RAM_OE	
	cbi		LCD_com0port,	Drv_E
	sbrs	r20, 6
	and		r21,	r18						//	Bit lschen
	sbrc	r20, 6
	or		r21,	r19						//	Bit setzen
	out		LCD_dataport,	r21			// Daten ausgeben
	nop
	cbi		LCD_com0port,	RAM_WE
	sbi		LCD_com0port,	Drv_E

nogmpixel:
	ldi		r19,	C_norm		 
	out	LCD_com0port,	r19
	sei
	
	pop	r25
	pop	r24
	pop	r22
	pop	r21
	pop	r19
	pop	r18
	pop	r17
exitbit2:
ret
//ca 81 takte +36
// -------------------------
// Invert Pixel

.global lcd_invpixel		// X: r25:r24  Sonstige register r21,r19,r18,r17
lcd_invpixel:				// Y: r22									
	push	r17
	push	r18
	push	r19
	push	r21
	push	r22
	push	r24
	push	r25

	mov r21, r24
	andi r21, 3
	ldi r19, 128
	cpi r21, 0
	breq exitshift2
shift2:						// r19 = 128>>r21
	lsr r19
	dec r21
	brne shift2
exitshift2:
	lsr r25
	ror r24
	lsr r25
	ror r24

//Frame 0
	cli

	out		LCD_dataport,	r22			//	ROW Adresse							
	out		LCD_com0port,	R_RAS		//	RAS	Signal
	out		LCD_dataport,	r24			//	Col Adresse
	out		LCD_com0port,	R_CAS		//	CAS	Signal
	cbi		LCD_com0port,	Drv_dir		//	B->A
	clr		r17
	out		LCD_dataddr,	r17			//	Port als eingang
	cbi		LCD_com0port,	Drv_E
	nop
	nop
	nop
	nop
	in		r21, LCD_datapin			//	Daten lesen
	sbi		LCD_com0port,	Drv_E
	ser		r17
	out		LCD_dataddr,	r17			//	Port als ausgang
	sbi		LCD_com0port,	Drv_dir		//  A->B
	sbi		LCD_com0port,	RAM_OE	
	cbi		LCD_com0port,	Drv_E
	eor		r21,	r19					//	Bit Invertieren
	out		LCD_dataport,	r21			// Daten ausgeben
	nop
	cbi		LCD_com0port,	RAM_WE
	sbi		LCD_com0port,	Drv_E
//frame1
	lds		r22, Graymode							// SW / 4GW mode?
	tst		r22
	breq	nogmipixel

	out		LCD_com0port,	R_RAS		//	RAS	Signal
	subi	r24,	-128
	out		LCD_dataport,	r24			//	Col Adresse
	out		LCD_com0port,	R_CAS		//	CAS	Signal
	cbi		LCD_com0port,	Drv_dir		//	B->A
	clr		r17
	out		LCD_dataddr,	r17			//	Port als eingang
	cbi		LCD_com0port,	Drv_E
	nop	
	nop
	nop
	nop
	in		r21, LCD_datapin			//	Daten lesen
	sbi		LCD_com0port,	Drv_E
	ser		r17
	out		LCD_dataddr,	r17			//	Port als ausgang
	sbi		LCD_com0port,	Drv_dir		//  A->B
	sbi		LCD_com0port,	RAM_OE	
	cbi		LCD_com0port,	Drv_E
	eor		r21,	r19						//	Bit invertieren
	out		LCD_dataport,	r21			// Daten ausgeben
	nop
	cbi		LCD_com0port,	RAM_WE
	sbi		LCD_com0port,	Drv_E

nogmipixel:
	ldi		r19,	C_norm		 
	out		LCD_com0port,	r19
	sei
	
	pop	r25
	pop	r24
	pop	r22
	pop	r21
	pop	r19
	pop	r18
	pop	r17
ret
//ca 81 takte +36

//-----------------------
// write byteeg
.global lcd_writebyteg		// X: r24
lcd_writebyteg:				// Y: r22
							// DATA: r20
	push	r20
	push	r21
	push	r23
	push	r24
	
	clr		r21
	clr		r23
	rol		r20
	rol		r21
	rol		r20
	rol		r23
	rol		r20
	rol		r21
	rol		r20
	rol		r23
	rol		r20
	rol		r21
	rol		r20
	rol		r23
	rol		r20
	rol		r21
	rol		r20
	rol		r23
	swap	r21
	swap	r23

	ldi		r20,	C_CAS_OE

	cli
	out		LCD_dataport,	r22			//	ROW adresse
	out		LCD_com0port,	R_RAS_W		//	RAS
																	//frame0
	out		LCD_dataport,	r24			//	COL Adresse
	out		LCD_com0port,	r20			//	CAS+OE+Drv_E
	out		LCD_dataport,	r21			//	Daten auf Port ausgeben
	
	out		LCD_com0port,	R_CAS_W		//	CAS_W
						
	out		LCD_com0port,	R_RAS_W		//	RAS
	subi	r24,	-128											//frame1
	out		LCD_dataport,	r24			//	COL Adresse
	out		LCD_com0port,	r20			//	CAS+OE	
	out		LCD_dataport,	r23			//	Daten auf Port ausgeben
	
	out		LCD_com0port,	R_CAS_W		//	CAS_W

	ldi		r20,	C_norm	
	out		LCD_com0port,	r20			//	normal zustand
	
	sei

	pop		r24
	pop		r23
	pop		r21
	pop		r20

	ret

//-----------------------
// write byteex

.global lcd_writebyteex		// X: r24		sonstige register r23, (r21)
lcd_writebyteex:			// Y: r22
	push	r20				// DATA: r20
	push	r21				//Textcol: r18
	push	r23				//Backcol: r16
	push	r24
	
	mov		r23, r20
	clr		r21				//Textcol
	sbrc	r18, 7
	mov		r21, r20
	sbrs	r18, 6
	clr		r20
	
	com		r23				//BGcol
	sbrc	r16, 7
	or		r21, r23
	sbrc	r16, 6
	or		r20, r23

	
	ldi	r23,	C_CAS_OE
	lsl	r24

	cli
	out		LCD_dataport,	r22			//	ROW adresse
															// frame0	
	out		LCD_com0port,	R_RAS_W		//	RAS		
	out		LCD_dataport,	r24			//	COL Adresse
	out		LCD_com0port,	r23			//	CAS+OE
	out		LCD_dataport,	r21			//	Daten auf Port ausgeben
	//nop
	out		LCD_com0port,	R_CAS_W		//	CAS_W
	swap	r21
	inc		r24							//	COL adresse +1
	out		LCD_com0port,	R_RAS_W		//	RAS
	out		LCD_dataport,	r24			//	COL Adresse
	out		LCD_com0port,	r23			//	CAS+OE	
	out		LCD_dataport,	r21			//	Daten auf Port ausgeben
	//nop
	out		LCD_com0port,	R_CAS_W		//	CAS_W
													//frame1
	lds		r21, Graymode							// SW / 4GW mode?
	tst		r21
	breq	nogmbyteex
																
	subi	r24,			-127		//  +128
	out		LCD_com0port,	R_RAS_W		//	RAS		
	out		LCD_dataport,	r24			//	COL Adresse
	out		LCD_com0port,	r23			//	CAS+OE
	out		LCD_dataport,	r20			//	Daten auf Port ausgeben
	//nop
	out		LCD_com0port,	R_CAS_W		//	CAS_W
	swap	r20
	inc		r24							//	COL adresse +1
	out		LCD_com0port,	R_RAS_W		//	RAS
	out		LCD_dataport,	r24			//	COL Adresse
	out		LCD_com0port,	r23			//	CAS+OE	
	out		LCD_dataport,	r20			//	Daten auf Port ausgeben
	//nop
	out		LCD_com0port,	R_CAS_W		//	CAS_W
nogmbyteex:
	ldi		r20,	C_norm	
	out		LCD_com0port,	r20			//	normal zustand
	
	sei
	
	pop	r24
	pop	r23
	pop	r21
	pop	r20
exitbyteex:
	ret										//ca 44 takte +32

//-----------------------
// write byte

.global lcd_writebyte		// X: r24		sonstige register r23
lcd_writebyte:				// Y: r22
							// DATA: r20
	push	r20
	push	r22
	push	r23
	push	r24
		
	ldi		r23,	C_CAS_OE
	lsl		r24

	cli
	out		LCD_dataport,	r22			//	ROW adresse
															//frame0
	out		LCD_com0port,	R_RAS_W		//	RAS
	out		LCD_dataport,	r24			//	COL Adresse
	out		LCD_com0port,	r23			//	CAS+OE
	out		LCD_dataport,	r20			//	Daten auf Port ausgeben
	//nop
	out		LCD_com0port,	R_CAS_W		//	CAS_W
	swap	r20
	inc		r24							//	COL adresse +1
	out		LCD_com0port,	R_RAS_W		//	RAS
	out		LCD_dataport,	r24			//	COL Adresse
	out		LCD_com0port,	r23			//	CAS+OE	
	out		LCD_dataport,	r20			//	Daten auf Port ausgeben
	//nop
	out		LCD_com0port,	R_CAS_W		//	CAS_W
															//frame1
	lds		r22, Graymode							// SW / 4GW mode?
	tst		r22
	breq	nogmbyte
		
	out		LCD_com0port,	R_RAS_W		//	RAS	
	subi	r24, -128
	out		LCD_dataport,	r24			//	COL Adresse
	out		LCD_com0port,	r23			//	CAS+OE
	out		LCD_dataport,	r20			//	Daten auf Port ausgeben
	//nop
	out		LCD_com0port,	R_CAS_W		//	CAS_W
	swap	r20
	dec		r24							//	COL adresse -1
	out		LCD_com0port,	R_RAS_W		//	RAS
	out		LCD_dataport,	r24			//	COL Adresse
	out		LCD_com0port,	r23			//	CAS+OE	
	out		LCD_dataport,	r20			//	Daten auf Port ausgeben
	//nop
	out		LCD_com0port,	R_CAS_W		//	CAS_W
nogmbyte:
	ldi		r20,	C_norm	
	out		LCD_com0port,	r20			//	normal zustand
	
	sei
	
	pop		r24
	pop		r23
	pop		r22
	pop		r20
exitbyte:
	ret										//ca 44 takte +30

//-----------------------
// write Nibbel

.global ram_writenibbel		// X: r24		sonstige register r23
ram_writenibbel:			// Y: r22
							// DATA: r20
	push	r23
		
	ldi		r23,	C_CAS_OE

	cli
	out		LCD_dataport,	r22			//	ROW adresse															
	out		LCD_com0port,	R_RAS_W		//	RAS
	sbi		LCD_adport,		RAM_A8		//  DRAM Set A8
	out		LCD_dataport,	r24			//	COL Adresse
	out		LCD_com0port,	r23			//	CAS+OE
	out		LCD_dataport,	r20			//	Daten auf Port ausgeben
	out		LCD_com0port,	R_CAS_W		//	CAS_W
	cbi		LCD_adport,		RAM_A8		//  DRAM Clear A8
	ldi		r23,	C_norm	
	out		LCD_com0port,	r23			//	normal zustand	
	sei

	pop		r23
	ret										//ca 19 takte +7

//-----------------------
// Invert byte

.global lcd_invnibbel		// X: r24		sonstige register r23
lcd_invnibbel:				// Y: r22
	push	r17
	push	r21
	push	r24

//Frame 0
	cli

	out		LCD_dataport,	r22			//	ROW Adresse							
	out		LCD_com0port,	R_RAS		//	RAS	Signal
	out		LCD_dataport,	r24			//	Col Adresse
	out		LCD_com0port,	R_CAS		//	CAS	Signal
	cbi		LCD_com0port,	Drv_dir		//	B->A
	clr		r17
	out		LCD_dataddr,	r17			//	Port als eingang
	cbi		LCD_com0port,	Drv_E
	nop
	nop
	nop
	nop
	in		r21, LCD_datapin			//	Daten lesen
	sbi		LCD_com0port,	Drv_E
	ser		r17
	out		LCD_dataddr,	r17			//	Port als ausgang
	sbi		LCD_com0port,	Drv_dir		//  A->B
	sbi		LCD_com0port,	RAM_OE	
	cbi		LCD_com0port,	Drv_E
	com		r21							//	Bit Invertieren
	out		LCD_dataport,	r21			// Daten ausgeben
	nop
	cbi		LCD_com0port,	RAM_WE
	sbi		LCD_com0port,	Drv_E
//frame1
	lds		r21, Graymode							// SW / 4GW mode?
	tst		r21
	breq	nogminibbel

	out		LCD_com0port,	R_RAS		//	RAS	Signal
	subi	r24,	-128
	out		LCD_dataport,	r24			//	Col Adresse
	out		LCD_com0port,	R_CAS		//	CAS	Signal
	cbi		LCD_com0port,	Drv_dir		//	B->A
	clr		r17
	out		LCD_dataddr,	r17			//	Port als eingang
	cbi		LCD_com0port,	Drv_E
	nop	
	nop
	nop
	nop
	in		r21, LCD_datapin			//	Daten lesen
	sbi		LCD_com0port,	Drv_E
	ser		r17
	out		LCD_dataddr,	r17			//	Port als ausgang
	sbi		LCD_com0port,	Drv_dir		//  A->B
	sbi		LCD_com0port,	RAM_OE	
	cbi		LCD_com0port,	Drv_E
	com		r21							//	Bit invertieren
	out		LCD_dataport,	r21			// Daten ausgeben
	nop
	cbi		LCD_com0port,	RAM_WE
	sbi		LCD_com0port,	Drv_E

nogminibbel:
	ldi		r21,	C_norm		 
	out		LCD_com0port,	r21
	sei
	
	pop	r24
	pop	r21
	pop	r17
	ret										//ca 44 takte +30

//------------------------
// Clear LCD
/* Old Clear
.global lcd_clear		// 		sonstige Register	R18,R19,R20,R21,r22
lcd_clear:				// 
	push	r18
	push	r19
	push	r20
	push	r21
	push	r22
	
	ldi	r18,	C_norm
	ldi	r22,	C_CAS_WCLR
	
	lds	r19,	XVSIZE					// Schleifenzhler laden

	clr	r20
	clr	r21
												// frame0
	wrow:
	cli
	out		LCD_dataport,	r20			//	ROW adresse
	out		LCD_com0port,	R_RAS_W		//	RAS
	out		LCD_dataport,	r21			//	COL Adresse
	out		LCD_com0port,	r22			//	CAS+WE
	inc		r21							//	COL adresse +1
	out		LCD_com0port,	R_RAS_W		//	RAS
	out		LCD_dataport,	r21			//	COL Adresse
	out		LCD_com0port,	r22			//	CAS+WE
	inc		r21							//	COL adresse +1
	out		LCD_com0port,	R_RAS_W		//	RAS
	out		LCD_dataport,	r21			//	COL Adresse
	out		LCD_com0port,	r22			//	CAS+WE
	inc		r21							//	COL adresse +1
	out		LCD_com0port,	R_RAS_W		//	RAS
	out		LCD_dataport,	r21			//	COL Adresse
	out		LCD_com0port,	r22			//	CAS+WE
				
	out		LCD_com0port,	r18			//	normal zustand
	sei

	inc		r21							//	COL adresse +1
	dec		r19
	brne	wrow

	lds	r19,	XVSIZE					// Schleifenzhler laden

	clr		r21
	inc		r20							//	Row A.	+1
	brne	wrow
													// frame1
	lds		r19, Graymode							// SW / 4GW mode?
	tst		r19
	breq	nogmclear
	
	lds		r19,	XVSIZE				// Schleifenzhlre laden
	clr		r20
	ldi		r21,	128

	wrowg:
	cli
	out		LCD_dataport,	r20			//	ROW adresse
	out		LCD_com0port,	R_RAS_W		//	RAS

	out		LCD_dataport,	r21			//	COL Adresse
	out		LCD_com0port,	r22			//	CAS+WE
	inc		r21							//	COL adresse +1
	out		LCD_com0port,	R_RAS_W		//	RAS
	out		LCD_dataport,	r21			//	COL Adresse
	out		LCD_com0port,	r22			//	CAS+WE
	inc		r21							//	COL adresse +1
	out		LCD_com0port,	R_RAS_W		//	RAS
	out		LCD_dataport,	r21			//	COL Adresse
	out		LCD_com0port,	r22			//	CAS+WE
	inc		r21							//	COL adresse +1
	out		LCD_com0port,	R_RAS_W		//	RAS
	out		LCD_dataport,	r21			//	COL Adresse
	out		LCD_com0port,	r22			//	CAS+WE		
	out		LCD_com0port,	r18			//	normal zustand
	sei

	inc		r21							//	COL adresse +1
	dec		r19
	brne	wrowg

	lds		r19,	XVSIZE
	ldi		r21,	128
	inc		r20							//	Row A.	+1
	brne	wrowg
nogmclear:

	pop	r22
	pop	r21
	pop r20
	pop	r19
	pop r18
ret										//bei V320 : SW: 119.078 takte  GW4: 238.120 takte

*/
//------------------------
// Clear LCD

.global lcd_clear		// 		sonstige Register	R18,R19,R20,R21,r22
lcd_clear:				// 
	push	r18
	push	r19
	push	r20
	push	r21
	push	r22
	
	ldi	r18,	C_norm
	ldi	r22,	C_CAS_WCLR
	
	ldi	r19,	XVSIZESW/4/4			//XVSIZE					// Schleifenzhler laden

	clr	r20
	clr	r21
												// frame0
	wrow:
	cli
	out		LCD_dataport,	r20			//	ROW adresse
	out		LCD_com0port,	R_RAS_W		//	RAS
	out		LCD_dataport,	r21			//	COL Adresse
	out		LCD_com0port,	r22			//	CAS+WE
	inc		r21							//	COL adresse +1
	out		LCD_com0port,	R_RAS_W		//	RAS
	out		LCD_dataport,	r21			//	COL Adresse
	out		LCD_com0port,	r22			//	CAS+WE
	inc		r21							//	COL adresse +1
	out		LCD_com0port,	R_RAS_W		//	RAS
	out		LCD_dataport,	r21			//	COL Adresse
	out		LCD_com0port,	r22			//	CAS+WE
	inc		r21							//	COL adresse +1
	out		LCD_com0port,	R_RAS_W		//	RAS
	out		LCD_dataport,	r21			//	COL Adresse
	out		LCD_com0port,	r22			//	CAS+WE
				
	out		LCD_com0port,	r18			//	normal zustand
	sei

	inc		r21							//	COL adresse +1
	dec		r19
	brne	wrow

	ldi		r19,	XVSIZESW/4/4			//XVSIZE					// Schleifenzhler laden

	clr		r21
	inc		r20							//	Row A.	+1
	brne	wrow

	pop	r22
	pop	r21
	pop r20
	pop	r19
	pop r18
ret			// 377889 Takte
