// Macros
.macro lcd4bitout
	out		LCD_com0port,	R_RAS			//RAS Signal
	out		LCD_dataport,	r16				//Column Adresse auf Port ausgeben
	out		LCD_com0port,	R_CAS			//CAS Signal
	inc		r16								//Column Adresse + 1
	out		LCD_com0port,	r19				//CP Signal (LCD)
.endm
.macro lcd16bitout
	lcd4bitout
	lcd4bitout
	lcd4bitout
	lcd4bitout
.endm
.macro lcd320bitout
	lcd16bitout
	lcd16bitout
	lcd16bitout
	lcd16bitout
	lcd16bitout

	lcd16bitout
	lcd16bitout
	lcd16bitout
	lcd16bitout
	lcd16bitout

	lcd16bitout
	lcd16bitout
	lcd16bitout
	lcd16bitout
	lcd16bitout

	lcd16bitout
	lcd16bitout
	lcd16bitout
	lcd16bitout
	lcd16bitout
.endm

// ------------------------------------------------------------------------------------
// Interrupt Displayausgabe und Touch
#ifdef	megaXX4
.global TIMER0_COMPA_vect
TIMER0_COMPA_vect:
#else
.global TIMER0_COMP_vect
TIMER0_COMP_vect:
#endif
	push	r16
	in r16, _SFR_IO_ADDR(SREG)
	sbi LCD_com0port, LCD_LP
	push	r16
	push	r19
	cbi LCD_com0port, LCD_LP
	
	ldi		r19,	C_CP
	cbi		LCD_com1port, LCD_FLM

	lds		r16,	YCnt							// Zeilenadresse laden
	out		LCD_dataport,	r16						// ROW Adresse auf Port ausgeben
	out		LCD_com0port,	R_RAS					//RAS Signal

	lds		r16,	viewstart2						// Spalten start Adresse laden

#ifdef FASTLOOP
	lcd320bitout
#else
	push	r20
	ldi		r20,	XSIZE/4/4						// Spaltencounter
Xshift:
	lcd16bitout
	dec		r20
	brne	Xshift
	pop		r20
#endif
	ldi		r16,	C_norm
	out		LCD_com0port,	r16

	lds		r16,	YCnt							// Zeilenadresse laden
	tst		r16
	brne	not_secline
	sbi		LCD_com1port, LCD_FLM
not_secline:

	inc		r16
	cpi		r16,	YSIZE							// Zeilenzhler berechnen
	brlo	not_firstline							// Bildende ?

#ifdef LCD_M
	in     R19,		LCD_com1port					// M/AC Signal
	ldi    R16,		(1<<LCD_M)    
	eor    R19,		R16			
	out    LCD_com1port, R19   
#endif

	lds		r16, Graymode							// SW / 4GW mode?
	tst		r16
	breq	nograymode

	lds		r16, viewstart							// 2x frame0 
	lds		r19, GrayCnt
	dec		r19
	brne	next_frame
	ldi		r19, 3
	subi	r16, -128								// 1 x frame1 
next_frame:										
	sts		GrayCnt, r19
	sts		viewstart2, r16
	clr		r16
nograymode:

#if ((defined(COMMAND_TIMEOUT))&&(COMMAND_TIMEOUT>0))
	lds		r19, ctimeout
	dec		r19
	sts		ctimeout, r19
#endif
	
	wdr
not_firstline:
	sts		YCnt, r16

#ifdef LCDTouch
// Touch  3 - x Takte
	lds		r19, tprogpos
	tst		r19
	brne	lcd_touch
lcd_touch_quit:
#endif
	pop r19
	pop r16
	out _SFR_IO_ADDR(SREG), r16
	pop r16
reti

//ca 445 takte max 662  (+64)
// -------------------------
// LCD Touch

#ifdef	LCDTouch
lcd_touch:
	push	ZL
	push	ZH
 
    cpi     r19,(10+1)							// Index auf Maximum prfen
    brsh    lcd_touch_fehler					// Index zu gross -> Fehler
    ldi     ZL,	lo8(pm(lcd_touch_Sprungtabelle))     // Tabellenzeiger laden, 16 Bit
    ldi     ZH,	hi8(pm(lcd_touch_Sprungtabelle))
    add     ZL,r19			                    // Index addieren, 16 Bit
    ldi     r16,0
    adc     ZH,r16
    ijmp										// indirekter Sprung in Sprungtabelle
 
lcd_touch_fehler:
 
; hier stehen jetzt alle Anweisungen fr den Fall, dass keiner der Vergleiche erfolgreich war
 
lcd_touch_ende:
	pop		ZH
	pop		ZL
	
	rjmp    lcd_touch_quit

// ------------------------------------------------------------------------------------
// Sprungtabelle
lcd_touch_Sprungtabelle:
    rjmp    lcd_touch_ende
    rjmp    lcd_touch_01
    rjmp    lcd_touch_02
    rjmp    lcd_touch_03
    rjmp    lcd_touch_04
	rjmp    lcd_touch_05
	rjmp    lcd_touch_06
	rjmp    lcd_touch_07
	rjmp    lcd_touch_08
	rjmp    lcd_touch_09
	rjmp    lcd_touch_10

// ------------------------------------------------------------------------------------
// 01	Touch gedrckt?	ADC fr X setzen / Mit berechnungen und senden beginnen
lcd_touch_01:		
	in		r16,	LCD_adpin
	andi	r16,	((1<<T_Xre)|(1<<T_Xli)|(1<<T_Yob)|(1<<T_Yun))
	brne	lcd_touch_01_notouch
													// Touch gedrckt
	sts		notouchcount,	r16												
	lds		r19,	tdatacount
	lds		r16,	Touchcount
	cp		r19,	r16								// ist max Datenstze anzahl erreicht
	brlo	lcd_touch_01_countk
	ldi		r16,	6								// Max anzahl Datenstze erreicht. Mit senden beginnen
	sts		tprogpos,	r16							// tprogpos = 6
	rjmp    lcd_touch_ende

lcd_touch_01_countk:
	ldi		r16,	2								// Mit nchsten datensatz beginnen
	sts		tprogpos,	r16							// tprogpos = 2
													
	ldi		r19,	AD_D_Touch_X					// ADC frs lesen von Touch X setzen
	out		LCD_adddr,	r19
	ldi		r19,	AD_P_Touch_X
	out		LCD_adport,	r19
	rjmp    lcd_touch_ende

lcd_touch_01_notouch:								// Touch nicht gedrckt
	lds		r16,	tpossent						//  
	tst		r16
	breq	lcd_touch_01_nosent

	lds		r19,	notouchcount
	lds		r16,	Touchcount
	cp		r19,	r16
	brsh	lcd_touch_01_notk
	inc		r19
	sts		notouchcount,	r19
	rjmp    lcd_touch_ende

lcd_touch_01_notk:		
#ifdef megaXX4
	lds		r16,	UCSR0A
	sbrs	r16,	UDRE0	
#else
	sbis    _SFR_IO_ADDR(UCSRA),UDRE                // Warten bis UDR fr das nchste Byte bereit ist
#endif   
	rjmp    lcd_touch_ende							 
	ldi		r16, 2
#ifdef megaXX4
	sts     UDR0, r16								// Byte Senden 02
#else
	out     _SFR_IO_ADDR(UDR), r16					// Byte Senden 02
#endif
	clr		r16
	sts		tpossent, r16							
lcd_touch_01_nosent:								// Daten auf 0 zurcksetzen
	lds		r19,	tdatacount
	tst		r19
#ifdef megaXX4
	breq	lcd_touch_ende2
#else
	breq	lcd_touch_ende
#endif

	sts		tdatacount, r16
	sts		ad_X,r16
	sts		ad_X+1,r16
	sts		ad_Y,r16
	sts		ad_Y+1,r16
lcd_touch_ende2:
    rjmp    lcd_touch_ende

// ------------------------------------------------------------------------------------
// 02	ADC fr X aktivieren
lcd_touch_02:		
	
	ldi		r19,	(1<<REFS0)| T_Yun
#ifdef megaXX4
	sts     ADMUX,	r19
	ldi		r19,	(1<<ADPS2)|(1<<ADPS1) | (1<<ADPS0) | (1<<ADEN) | (1<<ADSC)
	sts		ADCSRA,	r19
#else
	out     _SFR_IO_ADDR(ADMUX), r19
	sbi     _SFR_IO_ADDR(ADCSRA), ADSC
#endif
	
	ldi		r19,	3
	sts		tprogpos,	r19

    rjmp    lcd_touch_ende

// ------------------------------------------------------------------------------------
// 03	ADC X wert lesen und fr Y setzen
lcd_touch_03:
#ifdef megaXX4
	lds		r16,	ADCSRA
	sbrc	r16,	ADSC	
#else		
	sbic	_SFR_IO_ADDR(ADCSRA), ADSC
#endif
	rjmp    lcd_touch_ende
	
	lds		r16, ad_X
	lds		r19, ad_X+1
#ifdef megaXX4
	lds      r30, ADCL
	lds      r31, ADCH
#else
	in      r30, _SFR_IO_ADDR(ADCL)
	in      r31, _SFR_IO_ADDR(ADCH)
#endif
	add		r30,	r16
	adc		r31,	r19
	sts		ad_X,	r30
	sts		ad_X+1,	r31

	ldi		r19,	AD_D_Touch_Y
	out		LCD_adddr,	r19
	ldi		r19,	AD_P_Touch_Y
	out		LCD_adport,	r19

	ldi		r19,	4
	sts		tprogpos,	r19

    rjmp    lcd_touch_ende

// ------------------------------------------------------------------------------------
// 04	ADC fr Y aktivieren
lcd_touch_04:		

	ldi		r19,(1<<REFS0)| T_Xli
#ifdef megaXX4
	sts     ADMUX,	r19
	ldi		r19,	(1<<ADPS2)|(1<<ADPS1) | (1<<ADPS0) | (1<<ADEN) | (1<<ADSC)
	sts		ADCSRA,	r19
#else
	out     _SFR_IO_ADDR(ADMUX), r19
	sbi     _SFR_IO_ADDR(ADCSRA), ADSC
#endif
	ldi		r19,	5
	sts		tprogpos,	r19

    rjmp    lcd_touch_ende

// ------------------------------------------------------------------------------------
// 05	ADC Y wert lesen Port auf test setzen
lcd_touch_05:
#ifdef megaXX4
	lds		r16,	ADCSRA
	sbrc	r16,	ADSC	
#else		
	sbic	_SFR_IO_ADDR(ADCSRA), ADSC
#endif
	rjmp    lcd_touch_ende

	lds		r16,	ad_Y
	lds		r19,	ad_Y+1
#ifdef megaXX4
	lds     r30,	ADCL
	lds     r31,	ADCH
#else
	in      r30,	_SFR_IO_ADDR(ADCL)
	in      r31,	_SFR_IO_ADDR(ADCH)
#endif
	add		r30,	r16
	adc		r31,	r19
	sts		ad_Y,	r30
	sts		ad_Y+1,	r31

	ldi		r19,	AD_D_Touch_XY
	out		LCD_adddr,		r19
	ldi		r19,	AD_P_Touch_XY
	out		LCD_adport,	r19
	
	lds		r19,	tdatacount
	inc		r19
	sts		tdatacount,	r19

	ldi		r19,	1
	sts		tprogpos,	r19

    rjmp    lcd_touch_ende

// ------------------------------------------------------------------------------------
// Werte fr X berechnen/aufbereiten und 01 senden
lcd_touch_06:		
#ifdef megaXX4
	lds		r16,	UCSR0A
	sbrs	r16,	UDRE0	
#else
	sbis    _SFR_IO_ADDR(UCSRA),UDRE				// Warten bis UDR fr das nchste
#endif
	rjmp    lcd_touch_ende							// Byte bereit ist

	ldi		r16,	1
#ifdef megaXX4
	sts     UDR0, r16					// Byte Senden 01
#else
	out     _SFR_IO_ADDR(UDR), r16					// Byte Senden 01
#endif
	ldi		r16,	7
	sts		tprogpos,	r16

	lds		r16, tmode
	tst		r16
	brne	lcd_touch_06_mode_pixel
													// mode 0=adwerte senden
	
	lds		r30,	ad_X
	lds		r31,	ad_X+1
	lds		r16,	Touchcount
lcd_touch_06_adshift:	
	lsr		r16
	breq	lcd_touch_06_adok
	// Werte aufbereiten
	lsr		r31
	ror		r30
	rjmp	lcd_touch_06_adshift
lcd_touch_06_adok:

	sts		txsent,	r30
	sts		txsent+1, r31

	rjmp    lcd_touch_ende
lcd_touch_06_mode_pixel:							// mode 1=Pixelwerte senden
	// Pixel werte berechnen
	
	//push	r16		// adY Low
	push	r17		// adY High
	push	r18		// Yver	Low
	//push	r19		// Yver High
	push	r20		// temp1
	push	r21		// temp2
	push	r22		// Ypos
	push	r23		// count
	push	r24		// temp3

	ldi     ZL,	lo8(touchad_x)     // Array Zeiger laden, 16 Bit
    ldi     ZH,	hi8(touchad_x)

	ldi		r23,	7			// Schleifenzhler laden
	
	ldi		r24,	64		
	lds		r16,	ad_X	    	// Gespeicherte AD X werte laden
	lds		r17,	ad_X+1
	lds		r18,	touchad_x_min		// min wert abziehen
	lds		r19,	touchad_x_min+1
	sub		r16,	r18
    sbc		r17,	r19
	brsh	lcd_touch_06_n_0	// AD wert kleiner max?

	ldi		r22,	0				
	sts		txsent+1, r22

	rjmp	lcd_touch_06_cony_g
lcd_touch_06_n_0:
	ld		r18,	Z+			// Werte fr pos 128 laden
	ld		r19,	Z+

	ld		r20,	Z+			// Werte fr pos x laden
	ld		r21,	Z+
	cp		r16,	r18
	cpc		r17,	r19			// Vergleiche AD <-> Xver
	brlo	lcd_touch_06_cony_k1			// ist kleiner?

	ldi		r22,	1			// pos y grer 256
	add		r18,	r20	
	adc		r19,	r21
	sts		txsent+1, r22				
	ldi		r22,	128			// Pos auf 128 setzen
	rjmp	lcd_touch_06_cony
lcd_touch_06_cony_k1:
	ldi		r22,	0			// Pos y kleiner 256
	sub		r18,	r20	
	sbc		r19,	r21
	sts		txsent+1, r22
	ldi		r22,	128			// Pos auf 128 setzen

lcd_touch_06_cony:
	ld		r20,	Z+			// Werte fr pos x laden
	ld		r21,	Z+
	cp		r16,	r18
	cpc		r17,	r19			// Vergleiche AD <-> Xver
	brlo	lcd_touch_06_cony_k			// ist kleiner?

	add		r22,	r24			// Pos +temp
	add		r18,	r20	
	adc		r19,	r21				
	rjmp	lcd_touch_06_cony_e

lcd_touch_06_cony_k:
	sub		r22,	r24			// Pos -temp
	sub		r18,	r20	
	sbc		r19,	r21

lcd_touch_06_cony_e:
	lsr		r24
	dec		r23
	brne	lcd_touch_06_cony

	cp		r16,	r18
	cpc		r17,	r19				// Vergleiche AD <-> Xver
	brsh	lcd_touch_06_cony_g			// ist groeer?
	
	subi	r22,	1			// Pos -1
lcd_touch_06_cony_g:

	sts		txsent,	r22

	pop		r24
	pop		r23
	pop		r22
	pop		r21
	pop		r20
	pop		r18
	pop		r17

    rjmp    lcd_touch_ende

// ------------------------------------------------------------------------------------
// Wert fr X Low senden
lcd_touch_07:		
#ifdef megaXX4
	lds		r16,	UCSR0A
	sbrs	r16,	UDRE0	
#else
	sbis    _SFR_IO_ADDR(UCSRA),UDRE				// Warten bis UDR fr das nchste
#endif
	rjmp    lcd_touch_ende							// Byte bereit ist

	lds		r16,	txsent
#ifdef megaXX4
	sts     UDR0,	r16								// Byte Senden X Low
#else
	out     _SFR_IO_ADDR(UDR), r16					// Byte Senden X Low
#endif
	ldi		r16,	8
	sts		tprogpos,	r16

    rjmp    lcd_touch_ende

// ------------------------------------------------------------------------------------
// Wert fr X High senden und werte fr Y berechnen/aufbereiten
lcd_touch_08:		
#ifdef megaXX4
	lds		r16,	UCSR0A
	sbrs	r16,	UDRE0	
#else
	sbis    _SFR_IO_ADDR(UCSRA),UDRE				// Warten bis UDR fr das nchste
#endif
	rjmp    lcd_touch_ende							// Byte bereit ist
	lds		r16,	txsent+1
#ifdef megaXX4
	sts     UDR0,	r16								// Byte Senden X High
#else
	out     _SFR_IO_ADDR(UDR), r16					// Byte Senden X High
#endif
	ldi		r16,	9
	sts		tprogpos,	r16

	lds		r16, tmode
	tst		r16
	brne	lcd_touch_08_mode_pixel		
													// mode 0=adwerte senden
	lds		r30,	ad_Y
	lds		r31,	ad_Y+1
	lds		r16,	Touchcount
lcd_touch_08_adshift:	
	lsr		r16
	breq	lcd_touch_08_adok
	// Werte aufbereiten
	lsr		r31
	ror		r30
	rjmp	lcd_touch_08_adshift
lcd_touch_08_adok:

	sts		tysent,	r30
	sts		tysent+1, r31

	rjmp    lcd_touch_ende												
lcd_touch_08_mode_pixel:							// mode 1=Pixelwerte senden
	// Pixel werte berechnen
	
	//push	r16		// adX Low
	push	r17		// adX High
	push	r18		// Xver	Low
	//push	r19		// Xver High
	push	r20		// temp1
	push	r21		// temp2
	push	r22		// Xpos
	push	r23		// count
	push	r24		// temp3

	ldi     ZL,	lo8(touchad_y)     // Array Zeiger laden, 16 Bit
    ldi     ZH,	hi8(touchad_y)

	ldi		r23,	7			// Schleifenzhler laden
	ldi		r22,	128			// Pos auf 127 setzen
	ldi		r24,	64			
	lds		r16,	ad_Y	    	// Gespeicherte AD Y werte laden
	lds		r17,	ad_Y+1
	lds		r18,	touchad_y_min		// min wert abziehen
	lds		r19,	touchad_y_min+1
	sub		r16,	r18
    sbc		r17,	r19
	brsh	lcd_touch_08_n_0	// AD wert kleiner max?

	ldi		r22,	0				
	ldi		r23,	0

	rjmp	lcd_touch_08_conx_g
lcd_touch_08_n_0:
	ld		r18,	Z+			// Werte fr pos 128 laden
	ld		r19,	Z+

lcd_touch_08_conx:
	ld		r20,	Z+			// Werte fr pos y laden
	ld		r21,	Z+
	cp		r16,	r18
	cpc		r17,	r19			// Vergleiche AD <-> Xver
	brlo	lcd_touch_08_conx_k			// ist kleiner?

	add		r22,	r24			// Pos +temp
	add		r18,	r20	
	adc		r19,	r21				
	rjmp	lcd_touch_08_conx_e

lcd_touch_08_conx_k:
	sub		r22,	r24			// Pos -temp
	sub		r18,	r20	
	sbc		r19,	r21

lcd_touch_08_conx_e:
	lsr		r24
	dec		r23
	brne	lcd_touch_08_conx

	cp		r16,	r18
	cpc		r17,	r19				// Vergleiche AD <-> Xver
	brsh	lcd_touch_08_conx_g			// ist groeer?
	
	subi	r22,	1			// Pos -1
lcd_touch_08_conx_g:

	sts		tysent,	r22
	sts		tysent+1, r23

	pop		r24
	pop		r23
	pop		r22
	pop		r21
	pop		r20
	pop		r18
	pop		r17

    rjmp    lcd_touch_ende

// ------------------------------------------------------------------------------------
// Werte fr Y Low senden
lcd_touch_09:		
#ifdef megaXX4
	lds		r16,	UCSR0A
	sbrs	r16,	UDRE0	
#else
	sbis    _SFR_IO_ADDR(UCSRA),UDRE				// Warten bis UDR fr das nchste
#endif
	rjmp    lcd_touch_ende							// Byte bereit ist
	
	lds		r16,	tysent
#ifdef megaXX4
	sts     UDR0,	r16								// Byte Senden Y Low
#else
	out     _SFR_IO_ADDR(UDR), r16					// Byte Senden Y Low
#endif
	ldi		r16,	10
	sts		tprogpos,	r16

    rjmp    lcd_touch_ende

// ------------------------------------------------------------------------------------
// Werte fr Y High senden / Werte aus dem speicher wieder lschen
lcd_touch_10:		
#ifdef megaXX4
	lds		r16,	UCSR0A
	sbrs	r16,	UDRE0	
#else
	sbis    _SFR_IO_ADDR(UCSRA),UDRE				// Warten bis UDR fr das nchste
#endif
	rjmp    lcd_touch_ende							// Byte bereit ist

	lds		r16,	tysent+1
#ifdef megaXX4
	sts     UDR0,	r16								// Byte Senden Y High
#else
	out     _SFR_IO_ADDR(UDR), r16					// Byte Senden Y High
#endif

#ifdef Touchtest
	ldi		r16,	0
	sts		tprogpos,	r16
#else
	ldi		r16,	1
	sts		tprogpos,	r16
	sts		tpossent, r16

	clr		r16										// Daten auf 0 zurcksetzen				
	sts		tdatacount, r16							
	sts		ad_X,r16
	sts		ad_X+1,r16
	sts		ad_Y,r16
	sts		ad_Y+1,r16
#endif
    rjmp    lcd_touch_ende

#endif

