.macro	write_nibbel data	;(a)	// (data)
	out		LCD_com0port,	R_RAS_W		//	RAS
	out		LCD_dataport,	r24			//	COL Adresse
	out		LCD_com0port,	r16			//	CAS+OE
	out		LCD_dataport,	\data			//	Daten auf Port ausgeben
	out		LCD_com0port,	R_CAS_W		//	CAS_W
.endm

.macro	charcol_frame0
	clr		r19							// TC / BG color
	sbrc	r23,	5
	or		r19,	r20
	com		r20
	sbrc	r23,	7
	or		r19,	r20
.endm

.macro charcol_frame1
	clr		r19							// TC / BG color
	sbrc	r23,	6
	or		r19,	r20
	com		r20
	sbrc	r23,	4
	or		r19,	r20
.endm

// ------------------------------------------------------------------------------------
// write char

.global lcd_writechar		// X: r24
lcd_writechar:				// Y: r22							
							// C: r20
							// fontnr: r18								
	push	r16
	push	r17
	push	r18
	push	r19
	push	r20
	push	r21
	push	r22
	push	r23
	push	r24
	push	r30
	push	r31
	
    cpi     r18,(fontcount+1)							// Index auf Maximum prfen
    brsh    lcd_wchar_fehler					// Index zu gross -> Fehler
    ldi     ZL,	lo8(pm(lcd_wchar_Sprungtabelle))     // Tabellenzeiger laden, 16 Bit
    ldi     ZH,	hi8(pm(lcd_wchar_Sprungtabelle))
    add     ZL,r18			                    // Index addieren, 16 Bit
    ldi     r18,0
    adc     ZH,r18

	ldi		r16,	C_CAS_OE
	ldi		r17,	C_norm
	lds		r18,	Graymode
	lds		r23,	charcol

    ijmp										// indirekter Sprung in Sprungtabelle
 
lcd_wchar_fehler: 
// hier stehen jetzt alle Anweisungen fr den Fall, dass keiner der Vergleiche erfolgreich war

lcd_wchar_ende:
exitchar:
	pop		r31
	pop		r30
	pop		r24
	pop		r23
	pop		r22
	pop		r21
	pop		r20
	pop		r19
	pop		r18
	pop		r17	
	pop		r16

	ret

// ------------------------------------------------------------------------------------
// Sprungtabelle fr lcd_wchar
lcd_wchar_Sprungtabelle:
	rjmp    lcd_wchar_00						// Font 0 -> Benutzerzeichensatz
    rjmp    lcd_wchar_01						// Font 1 -> 4x6
    rjmp    lcd_wchar_02						// Font 2 -> 8x8
    rjmp    lcd_wchar_03						// Font 3 -> 8x12
#if defined(__AVR_ATmega32__) || defined(__AVR_ATmega324P__) || defined(__AVR_ATmega644P__)
    rjmp    lcd_wchar_04						// Font 4 -> 12x16
    rjmp    lcd_wchar_05						// Font 5 -> 16x26
#endif
#if defined(__AVR_ATmega644P__)
	rjmp    lcd_wchar_06						// Font 6 -> 24x40
#endif

// ------------------------------------------------------------------------------------
// Font Nr:0	Benutzer Font 4-40 x 1-40
lcd_wchar_00:

	//ldi		r16,	C_CAS_OE
	lds		r23,	textb_x
	lds		r19,	textb_y
	clr		r21

lcd_wchar_00_w:
	cli
	out		LCD_dataport,	r20			//	ROW Adresse		
	out		LCD_com0port,	R_RAS		//	RAS	Signal
	sbi		LCD_adport,		RAM_A8		//  DRAM Set A8
	out		LCD_dataport,	r21			//	Col Adresse
	out		LCD_com0port,	R_CAS		//	CAS	Signal
	cbi		LCD_com0port,	Drv_dir		//	B->A
	clr		r30
	out		LCD_dataddr,	r30			//	Port als eingang
	cbi		LCD_com0port,	Drv_E
	inc		r21	
	cbi		LCD_adport,		RAM_A8		//  DRAM Clear A8
	ser		r30
	in		r31, LCD_datapin			//	Daten lesen
	sbi		LCD_com0port,	Drv_E
	out		LCD_dataddr,	r30			//	Port als ausgang
		 
	out		LCD_com0port,	r17
																	//frame0
	out		LCD_dataport,	r22			//	ROW adresse
	
	write_nibbel	r31					//	Datenschreiben
	
	tst		r18							// SW / 4GW mode?
	breq	lcd_wchar_00_swm
	
	subi	r24, -128					//	Col A.	+128			// frame1

	write_nibbel	r31					//	Datenschreiben

	subi	r24, 128					//	Col A.	-128
lcd_wchar_00_swm:
	inc		r24							//	Col A.	+1
		 
	out		LCD_com0port,	r17
	sei

	dec		r23
	brne	lcd_wchar_00_w

	lds		r23,	textb_x
	sub		r24,	r23
	inc		r22							//	Row A.	+1

	dec		r19
	brne	lcd_wchar_00_w

	rjmp	lcd_wchar_ende

// ------------------------------------------------------------------------------------
// Font Nr:1	4x6						(322 Takte)

lcd_wchar_01:
	mov		ZL,		r20	
	ldi		ZH,		6
	mul		ZL,		ZH
	movw	ZL,		r0
	subi	ZL,		lo8(-(font01))
	sbci	ZH,		hi8(-(font01))
	clr		r1	
	ldi		r21,	6

lcd_wchar_01_w:
	lpm		r20,	Z+					// Byte laden
	swap	r20

	charcol_frame0						// TC / BG color Frame 0

	cli
	out		LCD_dataport,	r22			//	ROW adresse
	write_nibbel 	r19					//	Datenschreiben  frame 0
	
	tst		r18							// SW / 4GW mode?
	breq	lcd_wchar_01_swm								
	
	charcol_frame1						// TC / BG color Frame 1

	subi	r24,	-128
	write_nibbel 	r19					//	Datenschreiben  frame 1
	subi	r24,	128

lcd_wchar_01_swm:
	out		LCD_com0port,	r17			//	normal zustand
	sei
	
	inc		r22							//	Row A.	+1
	dec		r21
	brne	lcd_wchar_01_w

	rjmp	lcd_wchar_ende

// ------------------------------------------------------------------------------------
// Font Nr:2	8X8						(512 Takte)
lcd_wchar_02:
	mov		ZL, r20	
	ldi		ZH, 8
	mul		ZL, ZH
	movw	ZL, r0
	subi	ZL, lo8(-(font02))
	sbci	ZH, hi8(-(font02))
	ldi		r21, 8
	rjmp	lcd_wchar_02_w

// ------------------------------------------------------------------------------------
// Font Nr:3	8x12					(718 Takte)
lcd_wchar_03:
	mov		ZL, r20	
	ldi		ZH, 12
	mul		ZL, ZH
	movw	ZL, r0
	subi	ZL, lo8(-(font03))
	sbci	ZH, hi8(-(font03))
	ldi		r21, 12
	

lcd_wchar_02_w:
	clr		r1
lcd_wchar_03_w:
	lpm		r20,	Z+					// Byte laden

	charcol_frame0						// TC / BG color Frame 0

	cli
	out		LCD_dataport,	r22			//	ROW adresse
	write_nibbel 	r19					//	Datenschreiben  frame 0
	swap	r19
	inc		r24							//	Col A.	+1
	write_nibbel 	r19					//	Datenschreiben  frame 0

	tst		r18							// SW / 4GW mode?
	breq	lcd_wchar_03_swm								
	
	charcol_frame1						// TC / BG color Frame 1

	subi	r24,	-127				//	Col A.	+127
	write_nibbel 	r19					//	Datenschreiben  frame 1
	swap	r19
	inc		r24							//	Col A.	+1
	write_nibbel 	r19					//	Datenschreiben  frame 1
	subi	r24,	128					//	Col A.	-128

lcd_wchar_03_swm:
	dec		r24							//	Col A.	-1
	out		LCD_com0port,	r17			//	normal zustand
	sei
	
	inc		r22							//	Row A.	+1
	dec		r21
	brne	lcd_wchar_03_w

	rjmp	lcd_wchar_ende

#if defined(__AVR_ATmega32__) || defined(__AVR_ATmega324P__) || defined(__AVR_ATmega644P__)
// ------------------------------------------------------------------------------------
// Font Nr:4	12x16				(1391 Takte)
lcd_wchar_04:
	mov		ZL, r20	
	ldi		ZH, 32
	mul		ZL, ZH
	movw	ZL, r0
	subi	ZL, lo8(-(font04))
	sbci	ZH, hi8(-(font04))
	ldi		r21, 16
	clr		r1
	add		r21, r22
	inc		r24

lcd_wchar_04_w:
	
	lpm		r20,	Z+					// Byte laden
	
	cli
	out		LCD_dataport,	r22			//	ROW adresse
	charcol_frame0						// TC / BG color Frame 0
	
	write_nibbel 	r19					//	Datenschreiben  frame 0
	swap	r19
	inc		r24							//	Col A.	+1
	write_nibbel 	r19					//	Datenschreiben  frame 0

	tst		r18							// SW / 4GW mode?
	breq	lcd_wchar_04_swm_b0								
	
	charcol_frame1						// TC / BG color Frame 1

	subi	r24,	-127				//	Col A.	+127
	write_nibbel 	r19					//	Datenschreiben  frame 1
	swap	r19
	inc		r24							//	Col A.	+1
	write_nibbel 	r19					//	Datenschreiben  frame 1
	subi	r24,	128					//	Col A.	-128
lcd_wchar_04_swm_b0:
	
	lpm		r20,	Z+					// Byte laden
	swap	r20
	charcol_frame0						// TC / BG color Frame 0
	subi	r24,	2					//	Col A.	-2

	write_nibbel 	r19					//	Datenschreiben  frame 0
	
	tst		r18							// SW / 4GW mode?
	breq	lcd_wchar_04_swm_b1

	charcol_frame1						// TC / BG color Frame 1
	subi	r24,	-128				//	Col A.	+128
	write_nibbel 	r19					//	Datenschreiben  frame 1
	subi	r24,	128					//	Col A.	-128
lcd_wchar_04_swm_b1:

	subi	r24, -1						//	Col A.	+1
	out		LCD_com0port,	r17			//	normal zustand
	sei
	
	inc		r22							//	Row A.	+1
	cpse	r21, r22
	rjmp	lcd_wchar_04_w

	rjmp	lcd_wchar_ende

// ------------------------------------------------------------------------------------
// Font Nr:5	16x26			(2562 Takte)
lcd_wchar_05:
	cpi		r20,	font1624max
	brlo	lcd_wchar_05_ok
	ldi		r20,	32
lcd_wchar_05_ok:
	mov		ZL,		r20	
	ldi		ZH,		52
	mul		ZL,		ZH
	movw	ZL,		r0
	subi	ZL,		lo8(-(font05))
	sbci	ZH,		hi8(-(font05))
	ldi		r21,	26
	clr		r1
	add		r21,	r22
	subi	r24,	-2

lcd_wchar_05_w:
	lpm		r20,	Z+					// Byte laden
	charcol_frame0						// TC / BG color Frame 0

	cli
	out		LCD_dataport,	r22			//	ROW adresse
	write_nibbel 	r19					//	Datenschreiben  frame 0
	swap	r19
	inc		r24							//	Col A.	+1
	write_nibbel 	r19					//	Datenschreiben  frame 0

	tst		r18							// SW / 4GW mode?
	breq	lcd_wchar_05_swm_b0								
	
	charcol_frame1						// TC / BG color Frame 1

	subi	r24,	-127				//	Col A.	+127
	write_nibbel 	r19					//	Datenschreiben  frame 1
	swap	r19
	inc		r24							//	Col A.	+1
	write_nibbel 	r19					//	Datenschreiben  frame 1
	subi	r24,	128					//	Col A.	-128
lcd_wchar_05_swm_b0:

	subi	r24,	3
	lpm		r20,	Z+					// Byte laden
	charcol_frame0						// TC / BG color Frame 0
	write_nibbel 	r19					//	Datenschreiben  frame 0
	swap	r19
	inc		r24							//	Col A.	+1
	write_nibbel 	r19					//	Datenschreiben  frame 0

	tst		r18							// SW / 4GW mode?
	breq	lcd_wchar_05_swm_b1

	charcol_frame1						// TC / BG color Frame 1
	subi	r24,	-127				//	Col A.	+127
	write_nibbel 	r19					//	Datenschreiben  frame 1
	swap	r19
	inc		r24							//	Col A.	+1
	write_nibbel 	r19					//	Datenschreiben  frame 1
	subi	r24,	128				//	Col A.	-127
lcd_wchar_05_swm_b1:

	inc		r24							//	Col A.	+1
	out		LCD_com0port,	r17			//	normal zustand
	sei
	
	inc		r22							//	Row A.	+1
	cpse	r21, r22
	rjmp	lcd_wchar_05_w

	rjmp	lcd_wchar_ende

#endif
#if defined(__AVR_ATmega644P__)
// ------------------------------------------------------------------------------------
// Font Nr:6	24x40			(x Takte)
lcd_wchar_06:
	mov		ZL,		r20	
	ldi		ZH,		120
	mul		ZL,		ZH
	movw	ZL,		r0
	subi	ZL,		lo8(-(font06))
	sbci	ZH,		hi8(-(font06))
	ldi		r21,	40
	clr		r1
	add		r21,	r22
	subi	r24,	-4

lcd_wchar_06_w:
	lpm		r20,	Z+					// Byte laden
	charcol_frame0						// TC / BG color Frame 0

	cli
	out		LCD_dataport,	r22			//	ROW adresse
	write_nibbel 	r19					//	Datenschreiben  frame 0
	swap	r19
	inc		r24							//	Col A.	+1
	write_nibbel 	r19					//	Datenschreiben  frame 0

	tst		r18							// SW / 4GW mode?
	breq	lcd_wchar_06_swm_b0								
	
	charcol_frame1						// TC / BG color Frame 1

	subi	r24,	-127				//	Col A.	+127
	write_nibbel 	r19					//	Datenschreiben  frame 1
	swap	r19
	inc		r24							//	Col A.	+1
	write_nibbel 	r19					//	Datenschreiben  frame 1
	subi	r24,	128					//	Col A.	-128
lcd_wchar_06_swm_b0:

	subi	r24,	3
	lpm		r20,	Z+					// Byte laden
	charcol_frame0						// TC / BG color Frame 0
	write_nibbel 	r19					//	Datenschreiben  frame 0
	swap	r19
	inc		r24							//	Col A.	+1
	write_nibbel 	r19					//	Datenschreiben  frame 0

	tst		r18							// SW / 4GW mode?
	breq	lcd_wchar_06_swm_b1

	charcol_frame1						// TC / BG color Frame 1
	subi	r24,	-127				//	Col A.	+127
	write_nibbel 	r19					//	Datenschreiben  frame 1
	swap	r19
	inc		r24							//	Col A.	+1
	write_nibbel 	r19					//	Datenschreiben  frame 1
	subi	r24,	128				//	Col A.	-127
lcd_wchar_06_swm_b1:

	subi	r24,	3
	lpm		r20,	Z+					// Byte laden
	charcol_frame0						// TC / BG color Frame 0
	write_nibbel 	r19					//	Datenschreiben  frame 0
	swap	r19
	inc		r24							//	Col A.	+1
	write_nibbel 	r19					//	Datenschreiben  frame 0

	tst		r18							// SW / 4GW mode?
	breq	lcd_wchar_06_swm_b2

	charcol_frame1						// TC / BG color Frame 1
	subi	r24,	-127				//	Col A.	+127
	write_nibbel 	r19					//	Datenschreiben  frame 1
	swap	r19
	inc		r24							//	Col A.	+1
	write_nibbel 	r19					//	Datenschreiben  frame 1
	subi	r24,	128					//	Col A.	-127
lcd_wchar_06_swm_b2:

	subi	r24,	-3					//	Col A.	+1
	out		LCD_com0port,	r17			//	normal zustand
	sei
	
	inc		r22							//	Row A.	+1
	cpse	r21, r22
	rjmp	lcd_wchar_06_w

	rjmp	lcd_wchar_ende

#endif
/*
// ------------------------------------------------------------------------------------
// Alternative Font Nr:5	16x26 ohne TC und BG Color (1889 Takte)
lcd_wchar_05:
	mov		ZL, r20	
	ldi		ZH, 52
	mul		ZL, ZH
	movw	ZL, r0
	subi	ZL, lo8(-(font05))
	sbci	ZH, hi8(-(font05))
	ldi		r21, 26
	clr		r1
	add		r21, r22

lcd_wchar_05_w:
	lpm r20, Z+				// Byte laden
	lpm	r19, Z+

	cli
	out		LCD_dataport,	r22			//	ROW adresse
	write_nibbel 	r19					//	Datenschreiben  frame 0
	inc		r24							//	Col A.	+1

	swap	r19
	write_nibbel 	r19					//	Datenschreiben  frame 0
	inc		r24							//	Col A.	+1
	
	write_nibbel 	r20					//	Datenschreiben  frame 0
	inc		r24							//	Col A.	+1
	
	swap	r20
	write_nibbel 	r20					//	Datenschreiben  frame 0

	tst		r18
	breq	lcd_wchar_05_swm			// SW mode

	subi	r24, -126					//	Col A.	+126
	write_nibbel 	r19					//	Datenschreiben  frame 1
	dec		r24							//	Col A.	-1
	
	swap	r19
	write_nibbel 	r19					//	Datenschreiben  frame 1
	subi	r24, -3						//	Col A.	+3

	
	write_nibbel 	r20					//	Datenschreiben  frame 1
	dec		r24							//	Col A.	-1
	
	swap	r20
	write_nibbel 	r20					//	Datenschreiben  frame 1
	subi	r24, 127					//	Col A.	-127
lcd_wchar_05_swm:
	subi	r24, 3						//	Col A.	-3

	out		LCD_com0port,	r17			//	normal zustand
	sei
	
	inc		r22							//	Row A.	+1
	cpse	r21, r22
	rjmp	lcd_wchar_05_w

	rjmp	lcd_wchar_ende
*/