#define F_CPU		16000000UL

#define	Framerate	75

#define COMMAND_TIMEOUT	75			// Timeout in Frames
#define	STARTMON					// Startbildschirm anzeigen
#define LCDTouch					// LCD_Touch Routinen aktivieren
#define FASTLOOP					// Geschwindigkeit auf Kosten des Flashverbrauchs erhhen
//#define Touchtest					// Touch test
//#define Grafiktest 

#define XSIZE		320
#define YSIZE		240

#define XOScan		0
#define YOScan		0

#define	RELOAD		(F_CPU/8/(Framerate*(YSIZE+YOScan)))-1
#define XVSIZEGR	512
#define XVSIZESW	1024

// AD Port
#define		LCD_adport		_SFR_IO_ADDR(PORTA)
#define		LCD_adpin		_SFR_IO_ADDR(PINA)
#define		LCD_adddr		_SFR_IO_ADDR(DDRA)

#define 	T_Xre		2
#define 	T_Xli		0
#define 	T_Yob		3
#define 	T_Yun		1
#define 	RAM_A8		4
#define 	JP_0		5
#define		JP_1		6
#define		JP_2		7

// DATA Port
#define		LCD_dataport	_SFR_IO_ADDR(PORTB)
#define		LCD_datapin		_SFR_IO_ADDR(PINB)
#define		LCD_dataddr		_SFR_IO_ADDR(DDRB)

// COM0 Port
#define		LCD_com0port	_SFR_IO_ADDR(PORTC)
#define		LCD_com0pin		_SFR_IO_ADDR(PINC)
#define		LCD_com0ddr		_SFR_IO_ADDR(DDRC)

#define 	RAM_RAS		5
#define 	RAM_CAS		3
#define 	RAM_OE		7
#define 	RAM_WE		6
#define 	LCD_CP		0
#define 	LCD_LP		1
#define		Drv_E		2
#define		Drv_dir		4

// COM1 Port
#define		LCD_com1port	_SFR_IO_ADDR(PORTD)
#define		LCD_com1pin		_SFR_IO_ADDR(PIND)
#define		LCD_com1ddr		_SFR_IO_ADDR(DDRD)

#define 	LCD_OnOff	7
#define 	LCD_FLM		6
//#define 	LCD_Kon_PWM	5
//#define 	LCD_LED_PWM	4
#define 	LCD_M		3
//#define 	CTS			2
//#define 	TX			1
//#define 	RX			0

// com0

#define		C_norm		((1<<RAM_WE)|(1<<RAM_OE)|(1<<RAM_CAS)|(1<<RAM_RAS)|(0<<LCD_CP)|(0<<LCD_LP)|(1<<Drv_E)|(1<<Drv_dir))
#define		C_RAS		((1<<RAM_WE)|(0<<RAM_OE)|(1<<RAM_CAS)|(0<<RAM_RAS)|(0<<LCD_CP)|(0<<LCD_LP)|(1<<Drv_E)|(1<<Drv_dir))
#define		C_CAS		((1<<RAM_WE)|(0<<RAM_OE)|(0<<RAM_CAS)|(0<<RAM_RAS)|(0<<LCD_CP)|(0<<LCD_LP)|(1<<Drv_E)|(1<<Drv_dir))
#define		C_CP		((1<<RAM_WE)|(0<<RAM_OE)|(0<<RAM_CAS)|(0<<RAM_RAS)|(1<<LCD_CP)|(0<<LCD_LP)|(1<<Drv_E)|(1<<Drv_dir))

#define		C_RAS_W		((1<<RAM_WE)|(1<<RAM_OE)|(1<<RAM_CAS)|(0<<RAM_RAS)|(0<<LCD_CP)|(0<<LCD_LP)|(1<<Drv_E)|(1<<Drv_dir))
#define		C_CAS_OE	((1<<RAM_WE)|(1<<RAM_OE)|(0<<RAM_CAS)|(0<<RAM_RAS)|(0<<LCD_CP)|(0<<LCD_LP)|(0<<Drv_E)|(1<<Drv_dir))
#define		C_CAS_W		((0<<RAM_WE)|(1<<RAM_OE)|(0<<RAM_CAS)|(0<<RAM_RAS)|(0<<LCD_CP)|(0<<LCD_LP)|(0<<Drv_E)|(1<<Drv_dir))

#define		C_CAS_OECLR	((1<<RAM_WE)|(1<<RAM_OE)|(0<<RAM_CAS)|(0<<RAM_RAS)|(0<<LCD_CP)|(0<<LCD_LP)|(1<<Drv_E)|(1<<Drv_dir))
#define		C_CAS_WCLR	((0<<RAM_WE)|(1<<RAM_OE)|(0<<RAM_CAS)|(0<<RAM_RAS)|(0<<LCD_CP)|(0<<LCD_LP)|(1<<Drv_E)|(1<<Drv_dir))

// AD Port
#define		AD_P_noTouch	((0<<T_Xre)|(0<<T_Xli)|(0<<T_Yob)|(0<<T_Yun)|(1<<JP_0)|(1<<JP_1)|(1<<JP_2)|(0<<RAM_A8))
#define		AD_D_noTouch	((0<<T_Xre)|(0<<T_Xli)|(0<<T_Yob)|(0<<T_Yun)|(0<<JP_0)|(0<<JP_1)|(0<<JP_2)|(1<<RAM_A8))

#define		AD_P_Touch_XY	((1<<T_Xre)|(0<<T_Xli)|(0<<T_Yob)|(0<<T_Yun)|(1<<JP_0)|(1<<JP_1)|(1<<JP_2)|(0<<RAM_A8))
#define		AD_D_Touch_XY	((0<<T_Xre)|(0<<T_Xli)|(1<<T_Yob)|(0<<T_Yun)|(0<<JP_0)|(0<<JP_1)|(0<<JP_2)|(1<<RAM_A8))

#define		AD_P_Touch_X	((1<<T_Xre)|(0<<T_Xli)|(0<<T_Yob)|(0<<T_Yun)|(1<<JP_0)|(1<<JP_1)|(1<<JP_2)|(0<<RAM_A8))
#define		AD_D_Touch_X	((1<<T_Xre)|(1<<T_Xli)|(0<<T_Yob)|(0<<T_Yun)|(0<<JP_0)|(0<<JP_1)|(0<<JP_2)|(1<<RAM_A8))

#define		AD_P_Touch_Y	((0<<T_Xre)|(0<<T_Xli)|(0<<T_Yob)|(1<<T_Yun)|(1<<JP_0)|(1<<JP_1)|(1<<JP_2)|(0<<RAM_A8))
#define		AD_D_Touch_Y	((0<<T_Xre)|(0<<T_Xli)|(1<<T_Yob)|(1<<T_Yun)|(0<<JP_0)|(0<<JP_1)|(0<<JP_2)|(1<<RAM_A8))


#if defined(__AVR_ATmega32__) || defined(__AVR_ATmega324P__)
#define fontcount	5
#elif defined(__AVR_ATmega644P__)
#define fontcount	6
#else
#define fontcount	3
#endif

// Zeichensatzgre des 16x24 Fonds
#if defined(__AVR_ATmega644P__) && defined(STARTMON)
#define font1624max	180
#elif	defined(__AVR_ATmega644P__)
#define font1624max	210
#elif defined(__AVR_ATmega324P__) && defined(STARTMON)
#define font1624max	175
#elif defined(__AVR_ATmega324P__)
#define font1624max	190
#elif defined(__AVR_ATmega32__) && defined(STARTMON)
#define font1624max	180
#elif defined(__AVR_ATmega32__)
#define font1624max	200
#endif

#if defined(__AVR_ATmega644P__) || defined(__AVR_ATmega324P__) || defined(__AVR_ATmega164P__)
#define megaXX4
#endif